;nyquist plug-in
;version 4
;type process
;categories ""
;name "SetRMS"
;action "Setting RMS..."
  
;control target "Target RMS level" float "dB" -20 -40 -6
;control mode "Normalize stereo channels" choice "Linked stereo,Independently" 0

(setf target (db-to-linear target))

(defun mean-sq (sig ln)
  (let ((j 1) (total 0))
    (when (> ln 1000000)
      (setf j (round (/ ln 1000.0)))
      (setf ln 1000))
    (setf msq (snd-avg (mult sig sig) ln ln op-average))
    (dotimes (i j)
      (setf total (+ (snd-fetch msq) total)))
    (/ total j)))

(defun rms-mono (sig target ln)
  (mult sig
    (/ target (sqrt (mean-sq sig ln)))))

(defun rms-stereo (sig target ln)
  (mult sig
    (/ target
       (sqrt (/ (+ (mean-sq (aref sig 0) ln)
                   (mean-sq (aref sig 1) ln))
                2.0)))))

(if (= mode 1)  ;independent
    (multichan-expand #'rms-mono *track* target (truncate len))
    (if (arrayp *track*)  ;joined stereo
        (rms-stereo *track* target (truncate len))
        (rms-mono *track* target (truncate len)))) ;mono
